// 3-6
// https://gl-transitions.com/editor/Mosaic
#define PI 3.14159265359
precision highp float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform lowp float progress;
uniform lowp float ratio;
uniform vec4 tranx;

vec4 getToColor(vec2 uv) {
    return texture2D(inputImageTexture2, uv);
}
vec4 getFromColor(vec2 uv) {
    return texture2D(inputImageTexture, uv);
}
//曝光度
vec4 getExposure2(vec4 color, float value) {
    return vec4(color.rgb * pow(2.0, value), color.a);// rgb * 2^效果值
}
vec4 linecolor = vec4(0.1, 0.1, 0.1, 1.0);
void main() {
    vec2 pos = textureCoordinate;
    float pro = progress * 11.0;

    float linevalue = 1.0;
    bool isborder;
    float bordervalue = fract(pos.x * 10.0);
    float bordercheckvalue = 0.02;
    if (ratio > 1.0) {
        bordercheckvalue *= ratio;
    } else {
        bordercheckvalue /= ratio;
    }
    isborder = 0.5 - abs(bordervalue - 0.5) < bordercheckvalue;
    if (pro < 1.0) {
        linevalue = pro;
    } else if (pro > 10.0) {
        linevalue = 11.0 - pro;
    }
    pro -= 1.0;
    float mixvalue = fract(pro);
    float valuepos = pro - mixvalue;
    float cha = pos.x * 10.0 - valuepos;
    if (cha < 0.0) {
        gl_FragColor = getToColor(pos);
    } else if (cha > 1.0) {
        gl_FragColor = getFromColor(pos);
    } else {
        vec4 tocolor = getToColor(pos);
        float Exposurevalue=mixvalue<0.5?1.0:1.0-(mixvalue-0.5)*2.0;
        tocolor = getExposure2(tocolor, Exposurevalue);
        gl_FragColor = mix(getFromColor(pos), tocolor, mixvalue);
    }
    if (isborder) {
        gl_FragColor = mix(gl_FragColor, linecolor, linevalue);
    }
}
