// 3-6
// https://gl-transitions.com/editor/Mosaic
#define PI 3.14159265359
precision highp float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform lowp float progress;
uniform lowp float ratio;
uniform vec4 tranx;

vec4 getToColor(vec2 uv) {
    return texture2D(inputImageTexture2, uv);
}
vec4 getFromColor(vec2 uv) {
    return texture2D(inputImageTexture, uv);
}
//曝光度
vec4 getmovecolor(sampler2D Texture, vec2 pos, float off) {
    vec4 rtn;
    float maxoff = (1.0 - off) * 0.05 / 20.0;
    float offsize = 20.0;
    for (float i = 0.0; i < offsize; i++) {
        rtn += texture2D(Texture, vec2(pos.x, pos.y - i * maxoff));
    }
    rtn /= offsize;
    return rtn;
}
vec4 linecolor = vec4(0.1, 0.1, 0.1, 1.0);
void main() {
    vec2 pos = textureCoordinate;
    float pro = progress * 11.0;

    float linevalue = 1.0;
    bool isborder;
    float bordervalue = fract(pos.x * 10.0);
    float bordercheckvalue = 0.02;
    if (ratio > 1.0) {
        bordercheckvalue *= ratio;
    } else {
        bordercheckvalue /= ratio;
    }
    isborder = 0.5 - abs(bordervalue - 0.5) < bordercheckvalue;
    if (pro < 1.0) {
        linevalue = pro;
    } else if (pro > 10.0) {
        linevalue = 11.0 - pro;
    }
    pro -= 1.0;
    float mixvalue = fract(pro);
    float valuepos = pro - mixvalue;
    float cha = pos.x * 10.0 - valuepos;
    if (cha < 0.0) {
        gl_FragColor = getToColor(pos);
    } else if (cha > 1.0) {
        gl_FragColor = getFromColor(pos);
    } else {
    /**
        float move = sqrt(mixvalue);
        vec2 frompos = pos;
        frompos.y = frompos.y - move;
        if (frompos.y > 0.0) {
            gl_FragColor = getmovecolor(inputImageTexture,frompos,move);
        } else {
            gl_FragColor = getmovecolor(inputImageTexture2,vec2(pos.x, pos.y + (1.0 - move)),move);
        }*/
        float move = sqrt(mixvalue);
        vec2 frompos = pos;
        frompos.y = frompos.y - move;
        if (frompos.y < 0.0) {
            frompos.y += 1.0;
        }
        if (move < 0.5) {
            gl_FragColor = getmovecolor(inputImageTexture, frompos, move);
        } else {
            gl_FragColor = getmovecolor(inputImageTexture2, frompos, move);
        }

    }
    if (isborder) {
        gl_FragColor = mix(gl_FragColor, linecolor, linevalue);
    }
}
